<?php

namespace Modules\PaymentLog\Requests\Admin;

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\Rule;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;
use Modules\PaymentLog\Enums\PaymentLogAccStatusEnum;
use Modules\PaymentLog\Enums\PaymentLogStatusEnum;
use Modules\User\Enums\UserRoleEnum;

class PaymentLogRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        $role = UserRoleEnum::admins();
        if (! Auth::check()) {
            return false;
        }
        if(!in_array(Auth::user()->role, $role))
        {
            return false;
        }
        if(Auth::user()->hasModule('payment_logs'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $statuses = PaymentLogStatusEnum::dashboard_operations();
        $acc_statuses = PaymentLogAccStatusEnum::values();
        $rules = [
            'acc_status'=>[
                'required',
                'in:'.implode(',',$acc_statuses)
            ],
            'status'=>[
                'required',
                'in:'.implode(',',$statuses)
            ],
            'price'=>[
                'required',
                'numeric',
                'min:1'
            ],
            'description'=>[
                'nullable',
                'max:500'
            ],

        ];
        if (request('acc_status') == PaymentLogAccStatusEnum::CANTEEN->value)
        {
            $rules['canteen_id'] =
            [
                'required',
                Rule::exists('canteens','id')->whereNull('deleted_at')
            ];
        }
        else
        {
            $rules['user_id'] =
            [
                'required',
                Rule::exists('users','id')->whereNull('deleted_at')
            ];
        }


        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {
        $attributes= [
            'status'=>__('payment_logs.status'),
            'acc_status'=>__('payment_logs.acc_status'),
            'price'=>__('payment_logs.price'),
            'description'=>__('payment_logs.description'),
            'user_id'=>__('payment_logs.user_id'),
            'canteen_id'=>__('payment_logs.canteen_id'),
        ];

        return $attributes;
    }

    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
